3 # Copyright (c) 2005 Junio C Hamano
8 git-merge [options] <remote>...
9 git-merge [options] <msg> HEAD <remote>
11 summary show a diffstat at the end of the merge
12 n,no-summary don't show a diffstat at the end of the merge
13 squash create a single commit instead of doing a merge
14 commit perform a commit if the merge sucesses (default)
15 ff allow fast forward (default)
16 s,strategy= merge strategy to use
17 m,message= message to be used for the merge commit (if any)
25 test -z "$(git ls-files -u)" ||
26 die "You are in the middle of a conflicted merge."
31 all_strategies='recur recursive octopus resolve stupid ours subtree'
32 default_twohead_strategies='recursive'
33 default_octopus_strategies='octopus'
34 no_fast_forward_strategies='subtree ours'
35 no_trivial_strategies='recursive recur subtree ours'
42 rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" \
43 "$GIT_DIR/MERGE_SAVE" || exit 1
47 # Stash away any local modifications.
48 git diff-index -z --name-only $head |
49 cpio -0 -o >"$GIT_DIR/MERGE_SAVE"
53 if test -f "$GIT_DIR/MERGE_SAVE"
55 git reset --hard $head >/dev/null
56 cpio -iuv <"$GIT_DIR/MERGE_SAVE"
57 git update-index --refresh >/dev/null
61 finish_up_to_date () {
64 echo "$1 (nothing to squash)" ;;
72 echo Squashed commit of the following:
74 git log --no-merges ^"$head" $remoteheads
80 rlogm="$GIT_REFLOG_ACTION"
83 rlogm="$GIT_REFLOG_ACTION: $2"
87 echo "Squash commit -- not updating HEAD"
88 squash_message >"$GIT_DIR/SQUASH_MSG"
93 echo "No merge message -- not updating HEAD"
96 git update-ref -m "$rlogm" HEAD "$1" "$head" || exit 1
106 if test "$show_diffstat" = t
108 # We want color (if set), but no pager
109 GIT_PAGER='' git diff --stat --summary -M "$head" "$1"
114 # Run a post-merge hook
115 if test -x "$GIT_DIR"/hooks/post-merge
119 "$GIT_DIR"/hooks/post-merge 1
122 "$GIT_DIR"/hooks/post-merge 0
130 rh=$(git rev-parse --verify "$remote^0" 2>/dev/null) || return
131 bh=$(git show-ref -s --verify "refs/heads/$remote" 2>/dev/null)
132 if test "$rh" = "$bh"
134 echo "$rh branch '$remote' of ."
135 elif truname=$(expr "$remote" : '\(.*\)~[1-9][0-9]*$') &&
136 git show-ref -q --verify "refs/heads/$truname" 2>/dev/null
138 echo "$rh branch '$truname' (early part) of ."
139 elif test "$remote" = "FETCH_HEAD" -a -r "$GIT_DIR/FETCH_HEAD"
141 sed -e 's/ not-for-merge / /' -e 1q \
142 "$GIT_DIR/FETCH_HEAD"
144 echo "$rh commit '$remote'"
149 while test $# != 0; do
152 show_diffstat=false ;;
156 allow_fast_forward=t squash=t no_commit=t ;;
158 allow_fast_forward=t squash= no_commit= ;;
160 allow_fast_forward=t squash= no_commit= ;;
162 allow_fast_forward=t squash= no_commit=t ;;
164 allow_fast_forward=t squash= no_commit= ;;
166 allow_fast_forward=false squash= no_commit= ;;
169 case " $all_strategies " in
171 use_strategies="$use_strategies$1 " ;;
173 die "available strategies are: $all_strategies" ;;
191 test $# != 0 || usage
195 if branch=$(git-symbolic-ref -q HEAD)
197 mergeopts=$(git config "branch.${branch#refs/heads/}.mergeoptions")
198 if test -n "$mergeopts"
200 parse_config $mergeopts --
205 while test $args_left -lt $#; do shift; done
207 if test -z "$show_diffstat"; then
208 test "$(git config --bool merge.diffstat)" = false && show_diffstat=false
209 test -z "$show_diffstat" && show_diffstat=t
212 # This could be traditional "merge <msg> HEAD <commit>..." and the
213 # way we can tell it is to see if the second token is HEAD, but some
214 # people might have misused the interface and used a committish that
215 # is the same as HEAD there instead. Traditional format never would
216 # have "-m" so it is an additional safety measure to check for it.
218 if test -z "$have_message" &&
219 second_token=$(git rev-parse --verify "$2^0" 2>/dev/null) &&
220 head_commit=$(git rev-parse --verify "HEAD" 2>/dev/null) &&
221 test "$second_token" = "$head_commit"
227 elif ! git rev-parse --verify HEAD >/dev/null 2>&1
229 # If the merged head is a valid one there is no reason to
230 # forbid "git merge" into a branch yet to be born. We do
231 # the same for "git pull".
234 echo >&2 "Can merge only exactly one commit into empty head"
238 rh=$(git rev-parse --verify "$1^0") ||
239 die "$1 - not something we can merge"
241 git update-ref -m "initial pull" HEAD "$rh" "" &&
242 git read-tree --reset -u HEAD
246 # We are invoked directly as the first-class UI.
249 # All the rest are the commits being merged; prepare
250 # the standard merge summary message to be appended to
251 # the given message. If remote is invalid we will die
252 # later in the common codepath so we discard the error
254 merge_name=$(for remote
257 done | git fmt-merge-msg
259 merge_msg="${merge_msg:+$merge_msg$LF$LF}$merge_name"
261 head=$(git rev-parse --verify "$head_arg"^0) || usage
263 # All the rest are remote heads
264 test "$#" = 0 && usage ;# we need at least one remote head.
265 set_reflog_action "merge $*"
270 remotehead=$(git rev-parse --verify "$remote"^0 2>/dev/null) ||
271 die "$remote - not something we can merge"
272 remoteheads="${remoteheads}$remotehead "
273 eval GITHEAD_$remotehead='"$remote"'
274 export GITHEAD_$remotehead
276 set x $remoteheads ; shift
278 case "$use_strategies" in
282 var="`git config --get pull.twohead`"
285 use_strategies="$var"
287 use_strategies="$default_twohead_strategies"
290 var="`git config --get pull.octopus`"
293 use_strategies="$var"
295 use_strategies="$default_octopus_strategies"
301 for s in $use_strategies
303 for ss in $no_fast_forward_strategies
312 for ss in $no_trivial_strategies
316 allow_trivial_merge=f
325 common=$(git merge-base --all $head "$@")
328 common=$(git show-branch --merge-base $head "$@")
331 echo "$head" >"$GIT_DIR/ORIG_HEAD"
333 case "$allow_fast_forward,$#,$common,$no_commit" in
335 # No common ancestors found. We need a real merge.
338 # If head can reach all the merge then we are up to date.
339 # but first the most common case of merging one remote.
340 finish_up_to_date "Already up-to-date."
344 # Again the most common case of merging one remote.
345 echo "Updating $(git rev-parse --short $head)..$(git rev-parse --short $1)"
346 git update-index --refresh 2>/dev/null
348 if test -n "$have_message"
350 msg="$msg (no commit created; -m option ignored)"
352 new_head=$(git rev-parse --verify "$1^0") &&
353 git read-tree -v -m -u --exclude-per-directory=.gitignore $head "$new_head" &&
354 finish "$new_head" "$msg" || exit
359 # We are not doing octopus and not fast forward. Need a
363 # We are not doing octopus, not fast forward, and have only
365 git update-index --refresh 2>/dev/null
366 case "$allow_trivial_merge" in
368 # See if it is really trivial.
369 git var GIT_COMMITTER_IDENT >/dev/null || exit
370 echo "Trying really trivial in-index merge..."
371 if git read-tree --trivial -m -u -v $common $head "$1" &&
372 result_tree=$(git write-tree)
376 printf '%s\n' "$merge_msg" |
377 git commit-tree $result_tree -p HEAD -p "$1"
379 finish "$result_commit" "In-index merge"
387 # An octopus. If we can reach all the remote we are up to date.
391 common_one=$(git merge-base --all $head $remote)
392 if test "$common_one" != "$remote"
398 if test "$up_to_date" = t
400 finish_up_to_date "Already up-to-date. Yeeah!"
406 # We are going to make a new commit.
407 git var GIT_COMMITTER_IDENT >/dev/null || exit
409 # At this point, we need a real merge. No matter what strategy
410 # we use, it would operate on the index, possibly affecting the
411 # working tree, and when resolved cleanly, have the desired tree
412 # in the index -- this means that the index must be in sync with
413 # the $head commit. The strategies are responsible to ensure this.
415 case "$use_strategies" in
417 # Stash away the local changes so that we can try more than one.
422 rm -f "$GIT_DIR/MERGE_SAVE"
427 result_tree= best_cnt=-1 best_strategy= wt_strategy=
429 for strategy in $use_strategies
431 test "$wt_strategy" = '' || {
432 echo "Rewinding the tree to pristine..."
435 case "$single_strategy" in
437 echo "Trying merge strategy $strategy..."
441 # Remember which strategy left the state in the working tree
442 wt_strategy=$strategy
444 git-merge-$strategy $common -- "$head_arg" "$@"
446 if test "$no_commit" = t && test "$exit" = 0
449 exit=1 ;# pretend it left conflicts.
452 test "$exit" = 0 || {
454 # The backend exits with 1 when conflicts are left to be resolved,
455 # with 2 when it does not handle the given merge at all.
457 if test "$exit" -eq 1
460 git diff-files --name-only
461 git ls-files --unmerged
463 if test $best_cnt -le 0 -o $cnt -le $best_cnt
465 best_strategy=$strategy
472 # Automerge succeeded.
473 result_tree=$(git write-tree) && break
476 # If we have a resulting tree, that means the strategy module
477 # auto resolved the merge cleanly.
478 if test '' != "$result_tree"
480 if test "$allow_fast_forward" = "t"
482 parents=$(git show-branch --independent "$head" "$@")
484 parents=$(git rev-parse "$head" "$@")
486 parents=$(echo "$parents" | sed -e 's/^/-p /')
487 result_commit=$(printf '%s\n' "$merge_msg" | git commit-tree $result_tree $parents) || exit
488 finish "$result_commit" "Merge made by $wt_strategy."
493 # Pick the result from the best strategy and have the user fix it up.
494 case "$best_strategy" in
497 case "$use_strategies" in
499 echo >&2 "No merge strategy handled the merge."
502 echo >&2 "Merge with strategy $use_strategies failed."
508 # We already have its result in the working tree.
511 echo "Rewinding the tree to pristine..."
513 echo "Using the $best_strategy to prepare resolving by hand."
514 git-merge-$best_strategy $common -- "$head_arg" "$@"
518 if test "$squash" = t
525 done >"$GIT_DIR/MERGE_HEAD"
526 printf '%s\n' "$merge_msg" >"$GIT_DIR/MERGE_MSG"
529 if test "$merge_was_ok" = t
532 "Automatic merge went well; stopped before committing as requested"
539 git ls-files --unmerged |
540 sed -e 's/^[^ ]* / /' |
542 } >>"$GIT_DIR/MERGE_MSG"
544 die "Automatic merge failed; fix conflicts and then commit the result."